/* 
 * File:   cfgmain.h
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 15. září 2015, 13:58
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */

#ifndef CFGMAIN_H
#define	CFGMAIN_H

#ifdef	__cplusplus
extern "C" {
#endif

#include "cfgfile/cfgroot.h"


#define EMULATOR_VERSION "1.0.3"

#define CFGFILE_INI_FILENAME    "mz800emu.ini"

#ifdef EMULATOR_VERSION
#define CFGMAIN_EMULATOR_VERSION EMULATOR_VERSION
#else
#define CFGMAIN_EMULATOR_VERSION "unknown"
#endif

#define CFGMAIN_EMULATOR_VERSION_TEXT CFGMAIN_EMULATOR_VERSION


    extern struct st_CFGROOT *g_cfgmain;

    extern void cfgmain_init ( void );
    extern void cfgmain_exit ( void );
    extern char* cfgmain_create_timestamp ( void );


#ifdef	__cplusplus
}
#endif

#endif	/* CFGMAIN_H */

